﻿using Connected.Entities.Storage;
using System.Collections.Immutable;
using System.Data;

namespace Connected.Data.Storage
{
    public interface IStorageConnection : IMiddleware, IAsyncDisposable, IDisposable
	{
		StorageConnectionMode Behavior { get; }
		string ConnectionString { get; }

		Task Initialize(StorageConnectionArgs args);
		Task Commit();
		Task Rollback();
		Task Close();

		Task<int> Execute(IStorageCommand command);

		Task<ImmutableList<T>> Query<T>(IStorageCommand command);

		Task<T?> Select<T>(IStorageCommand command);

		Task<IDataReader?> OpenReader(IStorageCommand command);
	}
}
